/*
 * Gladeκmain.cեǤ. ԽɬפǤ.
 * GladeϤΥե񤭤ޤ.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "interface.h"
#include "support.h"
#include "rr_main.h"
#include "rr_screen.h"
#include "rr_switch.h"


int
main (int argc, char *argv[])
{
  GtkWidget *mainwin;
  RRSwitchGeometry winpos;
  gint pos_x =0, pos_y =0;
  gint size_w = 200, size_h = 220;
  gchar *start_pic;
  gboolean geoflag, result;

#ifdef ENABLE_NLS
  bindtextdomain (PACKAGE, PACKAGE_LOCALE_DIR);
  textdomain (PACKAGE);
#endif

  /* --- GTK+  */
  gtk_set_locale ();
  gtk_init (&argc, &argv);

  /* --- å */

  RRSwitch(argc, argv);
  if (RRSwitchGetHelp() == TRUE) return(0);
  geoflag = RRSwitchGetGeometry(&winpos);

  /* --- åڥ󥦥ɥ */
  RRMainInit();
  mainwin = create_mainwin();

  /* --- åڥ󥦥ɥɽ */
  gtk_widget_set_usize (mainwin, size_w, size_h);
  gtk_widget_show(mainwin);
  RRScreenInit(mainwin, RRGetParts(mainwin, "screen"),
	       size_w, size_h, TRUE);

  /* --- å꤬äؤ */
  start_pic = RRSwitchGetPicture();
  if (start_pic != NULL) {
    RRMainSetPicture(start_pic);
  }
  result = RRMainResize(0, 1.0, 1.0);

  /* -- ɽ */
  if (geoflag == TRUE) {
    gdk_window_get_size(mainwin->window, &pos_x, &pos_y);
    if (winpos.x < 0) {
      pos_x = gdk_screen_width() - pos_x + winpos.x;
    }
    else {
      pos_x = winpos.x;
    }
    if (winpos.y < 0) {
      pos_y = gdk_screen_height() - pos_y + winpos.y;
    }
    else {
      pos_y = winpos.y;
    }
    gtk_widget_set_uposition(mainwin, pos_x, pos_y);
  }

  /* --- ᥤ롼 */
  gtk_main ();

  /* ---  */
  RRMainFree();
  RRScreenFree();

  return 0;
}

